// *****************************************************************************
//  Game   version:  1.0     date: 04/30/2008
//  ----------------------------------------------------------------------------
//  
//  ----------------------------------------------------------------------------
//  Copyright (C) 2008 - All Rights Reserved
// *****************************************************************************
// 
// *****************************************************************************
#ifndef Game_h__
#define Game_h__
#include "GameDefines.h"
#include "BaseApp.h"
#include "Vector3.h"

namespace GameBase
{
	class cHumanView;
}

namespace MySound
{
	class ISound;
}

class cScore;
class cPongGameElement;

class cGame 
	: public GameBase::cBaseApp
{
public:
	enum PONGGAMEELEMENTS
	{
		PGE_UNKNOWN = -1,
		PGE_BALL,
		PGE_PADDLE_LEFT,
		PGE_PADDLE_RIGHT,
		PGE_WALL_UP,
		PGE_WALL_DOWN,
		PGE_TOTAL
	};
private:
	enum GAMESOUNDS
	{
		GS_UNKNOWN = -1,
		GS_BALL_WALL_COLLISION,
		GS_BALL_PADDLE_COLLISION,
		GS_WIN,
		GS_MAIN_MENU_MUSIC,
		GS_TOTAL
	};

public:
	GAME_API cGame(const Base::cString strName);
	cPongGameElement ** const VGetGameElements() const;
	Base::cVector3 VGetScreenTopLeftPos() const;
	Base::cVector3 VGetScreenBottomRightPos() const;
	void VRoundOver(const bool bPlayer1Won);
	void HandlePaddleAI(const float fElapsedTime);
	void MoveLeftPaddle(bool bMoveDown);

private:
	~cGame();
	void VOnInitialization(const HINSTANCE & hInstance, const int nCmdShow,
		const Base::cString & strOptionsFile);
	Base::cString VGetGameTitle() const;
	void VOnUpdate();
	void VCleanup();
	void Restart();
	bool VOnHandleMessage(const AI::Telegram & telegram);
	void VCreateHumanView();

private:
	int							m_iDisplayHeight ;		// the display height of the window
	int							m_iDisplayWidth ;		// the display width of the window
	cPongGameElement **			m_ppGameElements; // ptr to the gameelements
	cScore*						m_pScore;				// ptr to Scoreboard
	Base::cVector3				m_vScreenTopLeftPos;
	Base::cVector3				m_vScreenBottomRightPos;
};
#endif // Game_h__