// *****************************************************************************
//  MpongView   version:  1.0   Ankur Sheel  date: 2011/05/02
//  ----------------------------------------------------------------------------
//  
//  ----------------------------------------------------------------------------
//  Copyright (C) 2008 - All Rights Reserved
// *****************************************************************************
// 
// *****************************************************************************
#include "stdafx.h"
#include "MpongView.h"
#include "Game.h"
#include "PongGameElement.h"
#include "Camera.hxx"
#include "MessageDispatchManager.hxx"

using namespace Utilities;
using namespace Graphics;
using namespace GameBase;
using namespace Base;

// *****************************************************************************
cMPongView::cMPongView()
: m_pGame(NULL)
{
}

// *****************************************************************************
cMPongView::~cMPongView()
{
}

void cMPongView::VOnCreateDevice(IBaseApp * pGame,
								 const HINSTANCE & hInst,
								 const HWND & hWnd)
{
	cHumanView::VOnCreateDevice(pGame, hInst, hWnd);
	m_pGame = dynamic_cast<cGame *>(pGame);
	if (m_pCamera)
	{
		m_pCamera->VSetPosition(cVector3(0.0f, 0.0f, -20.0f));
		m_pCamera->VUpdate();
	}

}

// *****************************************************************************
bool cMPongView::VOnMsgProc( const Base::AppMsg & msg )
{
	if(!cHumanView::VOnMsgProc(msg))
	{
		if(msg.m_uMsg == WM_KEYDOWN)
		{
			if (msg.m_wParam == VK_ESCAPE  && !IsKeyLocked(VK_ESCAPE))
			{
				// lock the ESC key
				LockKey(VK_ESCAPE);
				PostQuitMessage(-1);
			}
			if (msg.m_wParam == 'S')
			{
				m_pGame->MoveLeftPaddle(true);
			}
			if (msg.m_wParam == 'W')
			{
				m_pGame->MoveLeftPaddle(false);
			}
		}
		else if (msg.m_uMsg == WM_KEYUP)
		{
			if (msg.m_wParam == VK_F2)
			{
				UnlockKey(VK_F2);
			}
			if (msg.m_wParam == VK_ESCAPE)
			{
				UnlockKey(VK_ESCAPE);
			}
		}
	}
	return true;
}

// *******************************************************************************************
void cMPongView::VRenderPrivate()
{
	for (int i=0; i<m_pGame->PGE_TOTAL; i++)
	{
		if(m_pGame->VGetGameElements() && m_pGame->VGetGameElements()[i])
		{
			m_pGame->VGetGameElements()[i]->VOnRender(m_pCamera);
		}
	}
	cHumanView::VRenderPrivate();
}
